From 94a163b4ac3dbb715226cb36ab928ba3d0a8647e Mon Sep 17 00:00:00 2001
From: Sergey Volkov <s.volkov@netris.ru>
Date: Thu, 26 Jul 2018 12:36:31 +0300
Subject: [PATCH] Android: fix Ti.UI.currentWindow leak

---
 .../modules/ui/src/java/ti/modules/titanium/ui/UIModule.java  |  1 -
 android/runtime/common/src/js/module.js                       |  6 ++----
 android/runtime/common/src/js/titanium.js                     | 11 +----------
 android/runtime/common/src/js/url.js                          |  2 +-
 4 files changed, 4 insertions(+), 16 deletions(-)

diff --git a/android/modules/ui/src/java/ti/modules/titanium/ui/UIModule.java b/android/modules/ui/src/java/ti/modules/titanium/ui/UIModule.java
index 138b7ca..8491da7 100644
--- a/android/modules/ui/src/java/ti/modules/titanium/ui/UIModule.java
+++ b/android/modules/ui/src/java/ti/modules/titanium/ui/UIModule.java
@@ -34,7 +34,6 @@ import android.widget.Toast;
 
 // clang-format off
 @Kroll.module
-@Kroll.dynamicApis(properties = { "currentWindow" })
 public class UIModule extends KrollModule implements Handler.Callback
 // clang-format on
 {
diff --git a/android/runtime/common/src/js/module.js b/android/runtime/common/src/js/module.js
index 30b9758..b0047b7 100644
--- a/android/runtime/common/src/js/module.js
+++ b/android/runtime/common/src/js/module.js
@@ -56,14 +56,12 @@ Module.runModule = function (source, filename, activityOrService) {
 	if (isService) {
 		module = new Module(id, null, {
 			currentService: activityOrService,
-			currentActivity: null,
-			currentWindow: null
+			currentActivity: null
 		});
 	} else {
 		module = new Module(id, null, {
 			currentService: null,
-			currentActivity: activityOrService,
-			currentWindow: activityOrService ? activityOrService.window : null
+			currentActivity: activityOrService
 		});
 	}
 
diff --git a/android/runtime/common/src/js/titanium.js b/android/runtime/common/src/js/titanium.js
index 5e82c4f..2f2d6cc 100644
--- a/android/runtime/common/src/js/titanium.js
+++ b/android/runtime/common/src/js/titanium.js
@@ -67,27 +67,18 @@ TitaniumWrapper.prototype = Titanium;
 Titanium.Wrapper = TitaniumWrapper;
 
 function UIWrapper(context, Android) {
-	this.currentWindow = context.currentWindow;
 	this.currentTab = context.currentTab;
 	this.currentTabGroup = context.currentTabGroup;
-
-	if (!context.currentWindow && Android.currentActivity) {
-		this.currentWindow = Android.currentActivity.window;
-	}
 }
 UIWrapper.prototype = Titanium.UI;
 
 function AndroidWrapper(context) {
 	this.currentActivity = context.currentActivity;
 	this.currentService = context.currentService;
-	var currentWindow = context.currentWindow;
 
 	if (!this.currentActivity) {
 		var topActivity;
-		if (currentWindow && currentWindow.window && currentWindow.window.activity) {
-			this.currentActivity = currentWindow.activity;
-
-		} else if (topActivity = Titanium.App.Android.getTopActivity()) {
+		if (topActivity = Titanium.App.Android.getTopActivity()) {
 			this.currentActivity = topActivity;
 		}
 	}
diff --git a/android/runtime/common/src/js/url.js b/android/runtime/common/src/js/url.js
index 24617b3..c4282f4 100644
--- a/android/runtime/common/src/js/url.js
+++ b/android/runtime/common/src/js/url.js
@@ -145,7 +145,7 @@ function urlToFilePath(url) {
 
 	} else if (data.protocol == "appdata-private:") {
 		if (!privateAppData) {
-			privateAppData = Ti.UI.currentWindow.activity.getDir("appdata", 0);
+			privateAppData = Ti.Android.currentActivity.getDir("appdata", 0);
 		}
 		return path.join(privateAppData, appId, data.pathname);
 
-- 
2.7.4

